#include "npstat/nm/RecurrenceCoeffs.hh"

namespace npstat {
    namespace Private {
        long double monicpoly(const std::vector<Recurrence>& rcoeffs,
                              const unsigned degree, const long double x)
        {
            long double polyk = 1.0L, polykm1 = 0.0L;
            for (unsigned k=0; k<degree; ++k)
            {
                const long double p = (x - rcoeffs[k].alpha)*polyk -
                    rcoeffs[k].beta*polykm1;
                polykm1 = polyk;
                polyk = p;
            }
            return polyk;
        }
    }
}
