#include "npstat/nm/ScalableClassicalOrthoPoly1D.hh"

namespace npstat {
    ScalableClassicalOrthoPoly1D::ScalableClassicalOrthoPoly1D(
        const AbsClassicalOrthoPoly1D& poly,
        const long double i_location, const long double i_scale)
            : poly_(0), location_(i_location), scale_(i_scale)
    {
        if (scale_ <= 0.0) throw std::invalid_argument(
            "In npstat::ScalableClassicalOrthoPoly1D::constructor: "
            "scale parameter must be positive");
        poly_ = poly.clone();
    }

    ScalableClassicalOrthoPoly1D::ScalableClassicalOrthoPoly1D(
        const ScalableClassicalOrthoPoly1D& r)
        : poly_(r.poly_->clone()), location_(r.location_), scale_(r.scale_)
    {
    }

    ScalableClassicalOrthoPoly1D& ScalableClassicalOrthoPoly1D::operator=(
        const ScalableClassicalOrthoPoly1D& r)
    {
        if (&r != this)
        {
            AbsClassicalOrthoPoly1D* p = r.poly_->clone();
            delete poly_;
            poly_ = p;
            location_ = r.location_;
            scale_ = r.scale_;
        }
        return *this;
    }
}
