#ifndef NPSTAT_PERFORMSCHULTZITERATION_HH_
#define NPSTAT_PERFORMSCHULTZITERATION_HH_

/*!
// \file performSchultzIteration.hh
//
// \brief Schultz iteration for improving matrix inverses
//
// Author: I. Volobouev
//
// July 2020
*/

namespace npstat {
    // The arrays must be dimensioned dim x dim.
    // "inverse" must contain an approximate inverse
    // on input. It will contain an improved inverse
    // on output, obtained by performing one Schultz iteration.
    // Multiple calls to this function can be made in a cycle.
    void performSchultzIteration(const long double* mat,
                                 unsigned dim,
                                 long double* inverse);
}

#endif // NPSTAT_PERFORMSCHULTZITERATION_HH_
