#include "npstat/stat/MatrixFilter1DBuilder.hh"

namespace npstat {
    PolyFilter1D* MatrixFilter1DBuilder::makeFilter(
        const double* /* taper */, unsigned /* lenTaper */,
        const unsigned binnum, const unsigned datalen) const
    {
        if (datalen != m_.nColumns()) throw std::invalid_argument(
            "In npstat::MatrixFilter1DBuilder::makeFilter: "
            "inconsistent data length");
        if (binnum >= m_.nRows()) throw std::out_of_range(
            "In npstat::MatrixFilter1DBuilder::makeFilter: "
            "bin number out of range");

        PolyFilter1D* filter = new PolyFilter1D(binnum);
        filter->resize(datalen);
        long double* f = &(*filter)[0];
        const double* data = m_[binnum];
        for (unsigned i=0; i<datalen; ++i)
            *f++ = *data++;
        return filter;
    }
}
